"""
Module in charge of testing the side bar component
"""

from epyk.core.Page import Report
from epyk.tests import test_statics

# Create a basic report object
rptObj = Report()

# Create a side bar component
rptObj.ui.side_bar()

# Create a anonymous CSS class.
# Its name is generated by the framework by default
cls_name = rptObj.style.anonymous_cls({"color": "red"})

# Attach the anonymous class to a text component
rptObj.ui.text("test").style.addCls(cls_name)

# Display the result in Codepen
rptObj.outs.browser.codepen(path=test_statics.OUTPUT_PATHS)
